unit synchMain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, Menus, ExtCtrls,
  frameSynchDraw, frameSynchDevice, SQLDBLib, RxDBGrid; // Подключаем модули фреймов

type
// Определяем тип TFrameClass

  TFrameClass = class of TFrame;

  { TformSynch }

  TformSynch = class(TForm)
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    PanelSynchConrolMenu: TPanel;
    PanelSynch: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure panelSynchSplitterMoved(Sender: TObject);

  private
    CurrentFrame: TFrame;
    FIsResizingByUser: Boolean;
    procedure ShowFrame(AFrameClass: TFrameClass);
    procedure UpdateProportion;
  public
    procedure ResetSplitterTo50;
  end;

var
  formSynch: TformSynch;

implementation

{$R *.lfm}



procedure TformSynch.FormCreate(Sender: TObject);
begin
  // Инициализация: показываем первый фрейм по умолчанию

  // первый контейнер (левая половина)
  //PanelSynch.Align := alLeft;
  //PanelSynch.Width := Self.ClientWidth div 2;
  //PanelSynch.BevelOuter := bvNone;
  ////PanelSynch.BorderSpacing.Around := 2;
  //
  //// Настройка разделителя
  //panelSynchSplitter.Align := alLeft;
  //panelSynchSplitter.Width := 8;
  //panelSynchSplitter.ResizeStyle := rsUpdate;
  //panelSynchSplitter.Color := clBtnFace;
  //panelSynchSplitter.MinSize := 100; // Минимальный размер панелей
  //
  //// второй контейнер (правая половина)
  //PanelSynchBD.Align := alClient; // Займет оставшееся пространство
  //PanelSynchBD.BevelOuter := bvNone;
  //PanelSynchBD.BorderSpacing.Around := 2;
  //
  ShowFrame(TframeSynchDevice);
    // Сохраняем начальную пропорцию
  //FProportion := PanelSynch.Width / (ClientWidth - panelSynchSplitter.Width);
  // Ограничения минимального размера формы
  Constraints.MinWidth := 600;
  Constraints.MinHeight := 400;

  //FProportion := 0.5; // начальная пропорция
end;

procedure TformSynch.FormResize(Sender: TObject);
begin
  //if not FIsResizingByUser then
  //  PanelSynch.Width := Round((ClientWidth - panelSynchSplitter.Width) * FProportion);
end;

procedure TformSynch.panelSynchSplitterMoved(Sender: TObject);
begin
  FIsResizingByUser := True;
  UpdateProportion;
  FIsResizingByUser := False;
end;

procedure TformSynch.ShowFrame(AFrameClass: TFrameClass);
begin
  // Удаляем текущий фрейм, если он существует
  if Assigned(CurrentFrame) then
    FreeAndNil(CurrentFrame);

  // Создаем новый фрейм указанного класса
  CurrentFrame := AFrameClass.Create(Self);
  with CurrentFrame do
  begin
    Parent := PanelSynch; // Размещаем фрейм на панели
    Align := alClient; // Растягиваем фрейм на всю панель
    Show; // Отображаем фрейм


    // Вызовем метод "активации", если он существует
    if CurrentFrame is TframeSynchDevice then
      TframeSynchDevice(CurrentFrame).Activate;
    //else if CurrentFrame is TframeSynchBD then
    //  TframeSynchBD(CurrentFrame).Activate;

  end;
end;

procedure TformSynch.UpdateProportion;
begin
  //if ClientWidth > panelSynchSplitter.Width then
  //  FProportion := PanelSynch.Width / (ClientWidth - panelSynchSplitter.Width);
end;

procedure TformSynch.ResetSplitterTo50;
begin
  //FProportion := 0.5;
  //PanelSynch.Width := Round((ClientWidth - panelSynchSplitter.Width) * FProportion);
end;


procedure TformSynch.MenuItem1Click(Sender: TObject);
begin
  // Показываем первый фрейм
  //ShowFrame(TframeSynchDraw);
end;

procedure TformSynch.MenuItem2Click(Sender: TObject);
begin
  // Показываем второй фрейм
  //ShowFrame(TframeSynchBD);
end;

end.

